
//#include <sndfile.h>

/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
// NE PAS MODIFIER JUSQU'A NOUVEL ORDRE!!!!
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QDebug>
#include <QDesktopWidget>
#include <QScreen>
#include <QMessageBox>
#include <QMetaEnum>
#include <stdio.h>
////////////////////////////////////////////////////////////////////////

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{    ui->setupUi(this);
     setGeometry(100, 100, 542, 390);
      Filtrage(ui->customPlot);
       setWindowTitle("QCustomPlot: "+demoName);
        statusBar()->clearMessage();
         currentDemoIndex = 20;
         // ui->customPlot->replot();
           QCPItemTracer *phaseTracer = new QCPItemTracer(ui->customPlot);
           ui->customPlot->addItem(phaseTracer);
            itemDemoPhaseTracer = phaseTracer ;
            itemDemoPhaseTracer->setInterpolating(true);
            itemDemoPhaseTracer->setStyle(QCPItemTracer::tsCircle);
            itemDemoPhaseTracer->setPen(QPen(Qt::red));
            itemDemoPhaseTracer->setBrush(Qt::red);
            itemDemoPhaseTracer->setSize(7);
           connect(ui->customPlot, SIGNAL(mouseMove(QMouseEvent*)), this,SLOT(showPointToolTip(QMouseEvent*)));
        //setToolTipDuration(1000);
}

////////////////////////////////////////////////////////////////////////
MainWindow::~MainWindow()
{    delete ui;}
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
// VOUS POUVEZ MODIFIER A PARTIR D'ICI!!!!
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

//ajouter ici toutes les fonctions que vous devez créer

/////////////////////////////////////////////////////////////////
void MainWindow::showPointToolTip(QMouseEvent *event)


//    int x = this->xAxis->pixelToCoord(event->pos().x());
//    int y = this->yAxis->pixelToCoord(event->pos().y());
//void MainWindow::onMouseMoveGraph(QMouseEvent* evt)
    {


    int y_data;
    int x = round(this->ui->customPlot->xAxis->pixelToCoord(event->pos().x()));
    int y = round(this->ui->customPlot->yAxis->pixelToCoord(event->pos().y()));

    if (this->ui->customPlot->graph(1)->data()->contains(x))
         y_data = this->ui->customPlot->graph(1)->data()->value(x).value;
    if  ( this->ui->customPlot->graph(1)->selectTest(QPointF(event->pos().x(),event->pos().y()),true) < 15 && abs(y - y_data) < 2)
       { setToolTip(QString("x=%1,y=%2").arg(x).arg(y_data));
        itemDemoPhaseTracer->setGraph(this->ui->customPlot->graph(1));
        itemDemoPhaseTracer->setGraphKey(x);
        this->ui->customPlot->replot();

    }

}


void MainWindow::Filtrage(QCustomPlot *customPlot)
{
    demoName = "Archi pour le TNS BVDP 2015";
    double nbBitsQuantADC=10; //nombre de bits pour les données en entrée
    double MaxQuantADC=pow(2,nbBitsQuantADC)-1; //valeur maximale pour les données en entrée

    bool affichageTemporel=FALSE; //mettre à TRUE pour un affichage en fonction du temps, et à FALSE pour un affichage en fonction du numéro d'échantillon

//Ajouter ici votre code pour définir les données manipulées, les initialisations, les appels des différentes fonctions....

//génération du signal d'entrée

//génération du signal de datation des échantillons

//génération du signal de sortie


    //gestion de la recopie des valeurs calculées par vous dans les données utilisées pour l'affichage
    int nbEchantillons=100;  // à remplacer par la valeur adéquate
    QVector<double> t(nbEchantillons), et(nbEchantillons),st(nbEchantillons);
    double tt[nbEchantillons], ett[nbEchantillons],stt[nbEchantillons];
    std::vector<double> auxVector;

 for (int i=0; i<nbEchantillons; i++)
    {
        //remplacer les valeurs écrites dans les tableaux par les valeurs issues de vos propres tableaux
        tt[i]=i;   //génération des dates associées aux échantillons
        ett[i]=i;  //génération des valeurs des échantillons d'entrée
        stt[i]=-i;  //génération des échantillons de sorties
    }

 auxVector.assign(tt, tt + nbEchantillons);
 t =  QVector<double>::fromStdVector(auxVector);
 auxVector.assign(ett, ett + nbEchantillons);
 et =  QVector<double>::fromStdVector(auxVector);
 auxVector.assign(stt, stt + nbEchantillons);
 st =  QVector<double>::fromStdVector(auxVector);

 /////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
// NE PAS MODIFIER JUSQU'A NOUVEL ORDRE!!!!
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
    // create graph and assign data to it:
    customPlot->addGraph();
    customPlot->graph(0)->setPen(QPen(Qt::green));
    customPlot->graph(0)->setData(t, et);
    // give the axes some labels:
    customPlot->xAxis->setLabel("t");
    customPlot->yAxis->setLabel("valeur  ");
    // set axes ranges, so we see all data:
    customPlot->xAxis->setRange(0, t[nbEchantillons-1]);
    customPlot->yAxis->setRange(0,MaxQuantADC);
    customPlot->addGraph();
    customPlot->graph(1)->setPen(QPen(Qt::red));
    customPlot->graph(1)->setData(t, st);
    QColor c(216,216,216);
    QBrush b(c);
    customPlot->setBackground(b);

    if (affichageTemporel==FALSE)
    {
        customPlot->graph(0)->setLineStyle(QCPGraph::lsImpulse);
        customPlot->graph(1)->setLineStyle(QCPGraph::lsImpulse);
        customPlot->graph(0)->setScatterStyle(QCPScatterStyle(QCPScatterStyle:: ssCircle, 5));
        customPlot->graph(1)->setScatterStyle(QCPScatterStyle(QCPScatterStyle:: ssCross, 5));
    }
    else
    {
        customPlot->graph(0)->setLineStyle(QCPGraph::lsStepLeft);
        customPlot->graph(1)->setLineStyle(QCPGraph::lsStepLeft);
    }
    customPlot->legend->setVisible(true);
    customPlot->legend->setFont(QFont("Helvetica",9));
    // set locale to english, so we get english decimal separator:
    customPlot->setLocale(QLocale(QLocale::English, QLocale::UnitedKingdom));
    customPlot->graph(0)->setName("e(t)");
    customPlot->graph(1)->setName("s(t)");

    // configure right and top axis to show ticks but no labels:
    // (see QCPAxisRect::setupFullAxesBox for a quicker method to do this)
    customPlot->xAxis2->setVisible(false);
    customPlot->xAxis2->setTickLabels(false);
    customPlot->yAxis2->setVisible(false);
    customPlot->yAxis2->setTickLabels(false);
    // make left and bottom axes always transfer their ranges to right and top axes:
    connect(customPlot->xAxis, SIGNAL(rangeChanged(QCPRange)), customPlot->xAxis2, SLOT(setRange(QCPRange)));
    connect(customPlot->yAxis, SIGNAL(rangeChanged(QCPRange)), customPlot->yAxis2, SLOT(setRange(QCPRange)));
    // let the ranges scale themselves so graph 0 fits perfectly in the visible area:
    customPlot->graph(0)->rescaleAxes();
    // same thing for graph 1, but only enlarge ranges (in case graph 1 is smaller than graph 0):
    customPlot->graph(1)->rescaleAxes(true);
    // Note: we could have also just called customPlot->rescaleAxes(); instead
    // Allow user to drag axis ranges with mouse, zoom with mouse wheel and select graphs by clicking:
    customPlot->setInteractions(QCP::iRangeDrag | QCP::iRangeZoom ); //| QCP::iSelectPlottables);
}
///////////////////////////////////////////////////////////////////////








































