#ifndef FILTRE_H
#define FILTRE_H

struct sFiltre
{
    int nbCoeffB;
    double * pCoeffB;
    int nbCoeffA;
    double * pCoeffA;
};

void initFiltre( sFiltre * filtre, int nbInitB, double *pBInit, int nbInitA, double *pAInit);

struct DataATracer
{
    int nbData;
    double * pX;
    double * pY;
};

void calculReponseFiltre(sFiltre * pFiltre, double * ek, double * sk, int nbPts);

void calculModule(sFiltre * pFiltre, double * pFreq, int nbFreq, double fEch, bool db, double * pModule);

void calculPhase(sFiltre * pFiltre, double * pFreq, int nbPts, double fEch, double * pPhase);

void initDataATracer( DataATracer * data, int nInit, double *pXInit, double *pYInit);

void calculModuleAnalogique(sFiltre * pFiltre, double * pFreq, int nbFreq, bool db, double * pModule);


class Filtre
{
public:
    Filtre();
};

#endif // FILTRE_H
